import 'package:example/module/module.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mobx/flutter_mobx.dart';
import 'package:healthrian_ble_interface/healthrian_ble_interface.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  @override
  Widget build(BuildContext context) {
    return const MaterialApp(
      home: MyHomePage(),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({
    super.key,
  });

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  final _module = WearECG();
  late final _ble = _module.ble;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(
        child: Observer(
          builder: (context) {
            return StreamBuilder(
              stream: _ble.streams.rawEcg,
              builder: (context, snapshot) {
                return Text(snapshot.data.toString());
              },
            );
            // return Column(
            //   mainAxisAlignment: MainAxisAlignment.center,
            //   children: [
            //     StreamBuilder(
            //       stream: _ble.streams.plotRTEcg,
            //       builder: (context, snapshot) {
            //         print(snapshot.data);
            //         return Text(snapshot.data.toString());
            //       },
            //     ),
            //     StreamBuilder(
            //       stream: _ble.streams.tap,
            //       builder: (context, snapshot) {
            //         print(snapshot.data);
            //         return Text(snapshot.data.toString());
            //       },
            //     ),
            //     StreamBuilder(
            //       stream: _ble.streams.battery,
            //       builder: (context, snapshot) {
            //         print(snapshot.data);
            //         return Text(snapshot.data.toString());
            //       },
            //     ),
            //   ],
            // );
          },
        ),
      ),
      floatingActionButton: Column(
        mainAxisAlignment: MainAxisAlignment.end,
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          FloatingActionButton(
            onPressed: _ble.connectAndRegister,
            child: const Icon(Icons.bluetooth),
          ),
          FloatingActionButton(
            onPressed: _module.ecg?.start,
            child: const Icon(Icons.play_arrow),
          ),
          FloatingActionButton(
            onPressed: _module.ecg?.stop,
            child: const Icon(Icons.stop),
          ),
          FloatingActionButton(
            onPressed: _ble.disconnectDevice,
            child: const Icon(Icons.bluetooth_disabled),
          ),
          FloatingActionButton(
            onPressed: () async {
              final a =
                  await _ble.points[Characteristics.CONTROL_POINT]?.read();
              print(a);
            },
          ),
          FloatingActionButton(
            onPressed: () async {
              final c = _ble.points[Characteristics.MEASUREMENT_ECG];
              if (c == null) return;
              print('1');
              await c.setNotifyValue(true);
              print('2');
              final stream = c.onValueReceived;
              print('3');
              await for (final s in stream) {
                print(s);
              }
              print('4');
            },
          ),
        ],
      ),
    );
  }
}
